/*                  - Mellanox Confidential and Proprietary -
 *
 *  Copyright (C) 2010-2011, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "COPYING".
 *
 */


#ifndef AR_MGR_API_H
#define AR_MGR_API_H


#ifdef __cplusplus
extern "C" {
#endif


/**
 * Create and initialize an instance of AdaptiverRoutingManager
 *
 * @param p_osm pointer to osm object
 *
 * @return int 0 if succeeded, otherwise 1
 */
int initARMgr(osm_opensm_t *p_osm);


/**
 * Wrapper for Run in the AdaptiverRoutingManager class
 * Update the osm event id
 * Run Adaptiver Routing Manager
 *
 * @param p_osm pointer to osm object
 * @param osm_event_id osm event id
 *
 * @return int 0 if succeeded, otherwise 1
 */
int runARMgr(osm_opensm_t *p_osm,
        osm_epi_event_id_t osm_event_id);

/**
 * Update the osm event id
 * Update the Adaptiver Routing Manager Database
 *
 * @param p_osm pointer to osm object
 * @param osm_event_id osm event id
 *
 * @return int
 */
int updateARMgr(osm_opensm_t *p_osm,
        osm_epi_event_id_t osm_event_id);

/**
 * Wrapper for SetOSMEventId in the AdaptiverRoutingManager
 * class
 * Update the osm event id
 *
 * @param p_osm pointer to osm object
 * @param osm_event_id osm event id
 */
void setOSMEventIdARMgr(osm_opensm_t *p_osm,
        osm_epi_event_id_t osm_event_id);

/**
 * Wrapper for Destructor in the AdaptiveRoutingManager class
 *
 * @param p_osm pointer to osm object
 */
void destroyARMgr(osm_opensm_t *p_osm);


#ifdef __cplusplus
} /* extern "C" */
#endif


#endif          /* AR_MGR_API_H */

