/*                  - Mellanox Confidential and Proprietary -
 *
 *  Copyright (C) 2010-2018, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
 *
 *  Except as specifically permitted herein, no portion of the information,
 *  including but not limited to object code and source code, may be reproduced,
 *  modified, distributed, republished or otherwise exploited in any form or by
 *  any means for any purpose without the prior written permission of Mellanox
 *  Technologies Ltd. Use of software subject to the terms and conditions
 *  detailed in the file "COPYING".
 *
 */

/* osm_config.h needs to be in all cpp files before all other includes */
#include <opensm/osm_config.h>

#include "ar_mgr_types.h"
#include "ar_kdor_algorithm.h"

//!!! TAMIR add to OSM
ARSWDataBaseEntry::~ARSWDataBaseEntry () {
    delete m_p_df_data;
    delete m_kdor_data; //KDOR
}

void ARSWDataBaseEntry::ClearKdorData() {
    m_kdor_data->m_required_plft_mode = 0;
    ClearKdorPlftData();
}

void ARSWDataBaseEntry::ClearKdorPlftData() {
    for (int i = 0 ; i < MAX_KDOR_PLFT_NUMBER ; ++i) {
        m_kdor_data->m_plft[i].m_max_lid = 0;
        memset(&m_kdor_data->m_plft[i].m_ar_lft, 0, sizeof(SMP_AR_LFT));
        memset(m_kdor_data->m_plft[i].m_to_set_lft_table,
               false, sizeof(bool) * AR_LFT_TABLE_NUM_BLOCKS_SX);
        m_kdor_data->m_plft[i].m_set_lft_top = false;
    }
}

